## kid3 3.4.2

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -D CMAKE_BUILD_TYPE=Release -D WITH_APPS=Qt -D CMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= ../kid3
# make
# cpack

project(kid3)

cmake_minimum_required(VERSION 2.8)
if (POLICY CMP0020)
  cmake_policy(SET CMP0020 OLD)
endif (POLICY CMP0020)
if (POLICY CMP0045)
  cmake_policy(SET CMP0045 OLD)
endif (POLICY CMP0045)
if (POLICY CMP0042)
  cmake_policy(SET CMP0042 OLD)
endif (POLICY CMP0042)

set(BUILD_SHARED_LIBS ON CACHE BOOL "build shared libraries")
set(WITH_QT4 OFF CACHE BOOL "force use of Qt4")
set(WITH_QT5 OFF CACHE BOOL "force use of Qt5")
set(WITH_QML    ON CACHE BOOL "build with QML")
set(WITH_UBUNTUCOMPONENTS OFF CACHE BOOL "use Ubuntu Components for QML")
set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_FFMPEG OFF CACHE BOOL "force use of FFmpeg for Chromaprint decoding")
set(WITH_CHROMAPRINT_FFMPEG OFF CACHE BOOL "link FFmpeg only for Chromaprint FFT")
set(WITH_GSTREAMER OFF CACHE BOOL "force use of GStreamer for Chromaprint decoding")
set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
set(WITH_GCC_PCH OFF CACHE BOOL "enable precompiled headers")
set(WITH_NO_MANCOMPRESS OFF CACHE BOOL "disable compressed manpages")
if (ANDROID)
  set(CMAKE_INSTALL_PREFIX "" CACHE PATH "install path prefix" FORCE)
  set(WITH_ID3LIB OFF CACHE BOOL "build with id3lib")
  set(WITH_VORBIS OFF CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC OFF CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT OFF CACHE BOOL "build with Chromaprint")
  set(WITH_PHONON OFF CACHE BOOL "build with Phonon")
else (ANDROID)
  set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
  set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC ON CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
  set(WITH_PHONON ON CACHE BOOL "build with Phonon")
endif (ANDROID)
if (APPLE OR WIN32)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
elseif (ANDROID)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qml" CACHE STRING "build applications (Qml;Qt;CLI;Test)")
else (APPLE OR WIN32)
  set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI;KDE" CACHE STRING "build applications (Qt;CLI;KDE;Test)")
endif (APPLE OR WIN32)
if (WIN32)
  set(WITH_READLINE OFF CACHE BOOL "build with readline")
else (WIN32)
  set(WITH_READLINE ON CACHE BOOL "build with readline")
endif (WIN32)

if (DEFINED WITH_KDE)
  unset(WITH_KDE CACHE)
  message(FATAL_ERROR "The variable WITH_KDE is no longer used. The KDE and Qt "
                      "applications can now be built together using common "
                      "libraries. Use WITH_APPS with a value of \"KDE\" for "
                      "the KDE application, \"Qt\" for the Qt application, "
                      "\"CLI\" for the command line application or "
                      "\"Qt;CLI;KDE\" for all. Default is -DWITH_APPS="
                      "\"${WITH_APPS}\".")
endif (DEFINED WITH_KDE)

if (WITH_APPS)
  string(TOLOWER "${WITH_APPS}" _apps_lower)
  foreach (_app ${_apps_lower})
    if (_app STREQUAL "qt")
      set(BUILD_QT_APP ON)
    elseif (_app STREQUAL "qml")
      set(BUILD_QML_APP ON)
      set(WITH_QML ON)
    elseif (_app STREQUAL "cli")
      set(BUILD_CLI_APP ON)
    elseif (_app STREQUAL "kde")
      set(BUILD_KDE_APP ON)
    elseif (_app STREQUAL "test")
      set(BUILD_TEST_APP ON)
    else ()
      message(SEND_ERROR "Invalid value ${_app} in WITH_APPS. "
                         "Supported applications are \"Qt;KDE;Test\".")
    endif ()
  endforeach ()
endif (WITH_APPS)

if (NOT BUILD_SHARED_LIBS AND WITH_QML)
  message(WARNING "Switching off WITH_QML because of static build")
  set(WITH_QML OFF)
  set(BUILD_QML_APP OFF)
endif (NOT BUILD_SHARED_LIBS AND WITH_QML)


# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 4)
set(CPACK_PACKAGE_VERSION_PATCH 2)
set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
#set(CPACK_PACKAGE_VERSION "git20160517")
set(RELEASE_YEAR 2016)

# Platform specific default installation paths
if (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_QMLDIR_DEFAULT "kid3.app/Contents/Resources/qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT "kid3.app/Contents/MacOS")
  set(WITH_PLUGINSDIR_DEFAULT "kid3.app/Contents/PlugIns")
elseif (WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_QMLDIR_DEFAULT "./qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT "./plugins")
elseif (ANDROID)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ":/translations")
  set(WITH_QMLDIR_DEFAULT ":/")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT ".")
  set(QT_ANDROID_APP_VERSION ${KID3_VERSION})
  set(QT_ANDROID_APP_VERSION_CODE 5)
else (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  if (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3/translations")
  else (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  endif (BUILD_KDE_APP OR BUILD_SHARED_LIBS)
  set(WITH_QMLDIR_DEFAULT "share/kid3/qml")
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib${LIB_SUFFIX}/kid3")
  set(WITH_PLUGINSDIR_DEFAULT "${WITH_LIBDIR_DEFAULT}/plugins")
endif (APPLE)

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
if (BUILD_KDE_APP)
  set(WITH_DBUSDIR "share/dbus-1/interfaces" CACHE STRING
      "dbus directory relative to CMAKE_INSTALL_PREFIX")
endif (BUILD_KDE_APP)
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_PLUGINSDIR ${WITH_PLUGINSDIR_DEFAULT} CACHE STRING
    "plugin directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_MANDIR ${WITH_DATAROOTDIR}/man CACHE STRING
    "man documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_QMLDIR ${WITH_QMLDIR_DEFAULT} CACHE STRING
    "QML directory relative to CMAKE_INSTALL_PREFIX")
if (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif (CMAKE_INSTALL_PREFIX)

if (APPLE)
file(RELATIVE_PATH CFG_DATAROOTDIR "/kid3.app/Contents/MacOS" /${WITH_DATAROOTDIR})
file(RELATIVE_PATH CFG_DOCDIR "/kid3.app/Contents/MacOS" /${WITH_DOCDIR})
file(RELATIVE_PATH CFG_TRANSLATIONSDIR "/kid3.app/Contents/MacOS" /${WITH_TRANSLATIONSDIR})
file(RELATIVE_PATH CFG_QMLDIR "/kid3.app/Contents/MacOS" /${WITH_QMLDIR})
file(RELATIVE_PATH CFG_PLUGINSDIR "/kid3.app/Contents/MacOS" /${WITH_PLUGINSDIR})
else (APPLE)
set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
set(CFG_QMLDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_QMLDIR})
file(RELATIVE_PATH CFG_PLUGINSDIR /${WITH_BINDIR} /${WITH_PLUGINSDIR})
endif (APPLE)
if (CFG_PLUGINSDIR STREQUAL "")
  set(CFG_PLUGINSDIR ".")
endif (CFG_PLUGINSDIR STREQUAL "")
if (WITH_QMLDIR MATCHES "^:/")
  set(HAVE_QMLDIR_IN_QRC 1)
endif (WITH_QMLDIR MATCHES "^:/")
if (WITH_TRANSLATIONSDIR MATCHES "^:/")
  set(HAVE_TRANSLATIONSDIR_IN_QRC 1)
endif (WITH_TRANSLATIONSDIR MATCHES "^:/")
set(CFG_QMLSRCDIR "${kid3_SOURCE_DIR}/src/qml")

find_package(Threads)
find_package(PythonInterp REQUIRED)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

# Find Qt
set(_qt5Dir)
set(QT_EXECUTABLE_COMPILE_FLAGS)
if (NOT WITH_QT4)
  string(REGEX MATCH "^(.*[Qq]t[/\\]?5.*).bin.qmake.*" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
  if (_qt5Dir)
    set(_qt5Dir ${CMAKE_MATCH_1})
  endif (_qt5Dir)
endif (NOT WITH_QT4)

if (NOT WITH_QT5 AND NOT _qt5Dir)
  set(_QT4_COMPONENTS QtCore QtGui QtNetwork QtXml)
  if (WITH_QML)
    set(_QT4_COMPONENTS ${_QT4_COMPONENTS} QtDeclarative)
  endif (WITH_QML)
  if (WIN32)
    set(QT_USE_QTMAIN TRUE)
  endif (WIN32)
  set(QT_USE_QTDBUS ${WITH_DBUS})
  find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS})
  if (Qt4_FOUND OR QT4_FOUND)
    include (${QT_USE_FILE})
    if (NOT WITH_QT4)
      message(STATUS "Qt4 found, explicitly set WITH_QT5 or QT_QMAKE_EXECUTABLE to use a different version.")
    endif (NOT WITH_QT4)
  endif (Qt4_FOUND OR QT4_FOUND)
endif (NOT WITH_QT5 AND NOT _qt5Dir)

if (NOT WITH_QT4 AND NOT Qt4_FOUND AND NOT QT4_FOUND)
  if (_qt5Dir)
    set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
    find_package(Qt5Core)
    if (Qt5Core_FOUND)
      message(STATUS "Qt5Core found in ${_qt5Dir}")
      set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
      set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
      set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
      set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
      set(Qt5Multimedia_DIR "${_qt5Dir}/lib/cmake/Qt5Multimedia")
      set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
      set(Qt5Test_DIR "${_qt5Dir}/lib/cmake/Qt5Test")
      if (WITH_DBUS)
        set(Qt5DBus_DIR "${_qt5Dir}/lib/cmake/Qt5DBus")
      endif (WITH_DBUS)
      if (WITH_QML)
        set(Qt5Qml_DIR "${_qt5Dir}/lib/cmake/Qt5Qml")
        set(Qt5Quick_DIR "${_qt5Dir}/lib/cmake/Qt5Quick")
      endif (WITH_QML)
      if (BUILD_QML_APP)
        set(Qt5Svg_DIR "${_qt5Dir}/lib/cmake/Qt5Svg")
      endif (BUILD_QML_APP)
    endif (Qt5Core_FOUND)
  else (_qt5Dir)
    find_package(Qt5Core)
  endif (_qt5Dir)
  if (Qt5Core_FOUND)
    set(HAVE_QT5 1)
    set(WITH_PHONON OFF)
    set(QT_INCLUDES)
    set(QT_DEFINITIONS)
    set(QT_LIBRARIES)
    set(_qt5Components Core Gui Widgets Network Xml Multimedia)
    if (WITH_DBUS)
      set(_qt5Components ${_qt5Components} DBus)
    endif (WITH_DBUS)
    if (WITH_QML)
      set(_qt5Components ${_qt5Components} Qml Quick)
    endif (WITH_QML)
    if (BUILD_QML_APP)
      set(_qt5Components ${_qt5Components} Svg)
    endif (BUILD_QML_APP)
    foreach (_qt5Component ${_qt5Components})
      find_package("Qt5${_qt5Component}")
      if (Qt5${_qt5Component}_FOUND)
        set(QT_INCLUDES ${QT_INCLUDES} ${Qt5${_qt5Component}_INCLUDE_DIRS})
        set(QT_DEFINITIONS ${QT_DEFINITIONS} ${Qt5${_qt5Component}_DEFINITIONS})
        set(QT_LIBRARIES ${QT_LIBRARIES} ${Qt5${_qt5Component}_LIBRARIES})
      endif (Qt5${_qt5Component}_FOUND)
    endforeach ()
    find_package(Qt5LinguistTools)
    find_package(Qt5Test)
    set(QT_QTTEST_LIBRARY Qt5::Test)
    set(QT_QTTEST_INCLUDE_DIR ${Qt5Test_INCLUDE_DIRS})
    if (Qt5DBus_FOUND)
      set(HAVE_QTDBUS 1)
    endif (Qt5DBus_FOUND)
    set(QT_EXECUTABLE_COMPILE_FLAGS ${Qt5Core_EXECUTABLE_COMPILE_FLAGS})

=== src/app/qt/CMakeLists.txt ===
set(qt_SRCS
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  kid3qtapplication.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
set(qt_MOC_HDRS
  kid3mainwindow.h
  kid3qtapplication.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
)
qt4_wrap_cpp(qt_GEN_MOC_SRCS ${qt_MOC_HDRS})
set(qt_SRCS ${qt_SRCS} ${qt_GEN_MOC_SRCS})

if (APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(qt_SRCS ${qt_SRCS} qt.conf)
elseif (WIN32)
  if (MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif (MINGW)
  # add Windows resource file with icon
  set(qt_SRCS ${qt_SRCS} kid3win.rc)
endif (APPLE)

if (UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT kid3-qt.desktop
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.py
      <${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop >kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications")
  add_custom_command(OUTPUT kid3-qt.appdata.xml
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixappdata.py
      ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml >kid3-qt.appdata.xml
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml
  )
  add_custom_target("appdata-file" ALL DEPENDS kid3-qt.appdata.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.appdata.xml
    DESTINATION "${WITH_DATAROOTDIR}/appdata")
  if (GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cdn ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-apps-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../hisc-apps-kid3.svgz
    )
    set(qt_SRCS ${qt_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else (GZIP_PROGRAM)
    install(FILES ../hisc-apps-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif (GZIP_PROGRAM)
  install(FILES ../hi128-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi64-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi48-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi32-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../hi16-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif (APPLE)
  install(FILES ../hi48-apps-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif (UNIX AND NOT APPLE)

add_definitions(${QT_DEFINITIONS} ${QT_EXECUTABLE_COMPILE_FLAGS})
set(qt_RESOURCES kid3.qrc)
qt4_add_resources(qt_GEN_RCS ${qt_RESOURCES})
add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  ${qt_SRCS} ${qt_GEN_RCS})

target_link_libraries(${KID3_EXECUTABLE} kid3-gui -lstdc++)

if (APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
endif (APPLE)

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if (APPLE OR WIN32)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
   "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if (APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
  endif (APPLE)
  if (WIN32)
    set(bundle_app
      "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
  endif (WIN32)
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG and Phonon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}")

  if (HAVE_QT5)
    if (APPLE)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION kid3.app/Contents/MacOS
        FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    elseif (WIN32)
      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (APPLE)
  endif (HAVE_QT5)

  if (HAVE_PHONON)
    install(DIRECTORY "${QT_PLUGINS_DIR}/phonon_backend"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING
        PATTERN "*d4${CMAKE_SHARED_LIBRARY_SUFFIX}" EXCLUDE
        PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif (HAVE_PHONON)

  if (WIN32)
    string(REGEX MATCH "(i586-mingw32msvc-g\\+\\+|i686-w64-mingw32-g\\+\\+)"
           _crossMingwMatch "${CMAKE_CXX_COMPILER}")
    if (_crossMingwMatch)
      # Avoid error "/usr/bin/ldd failed: 1" from GetPrerequisites.cmake:800
      # when building a Windows package from Linux with CMake 3.5.
      install(CODE "
      set(gp_tool DO_NOT_USE)
      ")
    endif (_crossMingwMatch)
  endif (WIN32)

  # Install and fix up all dependencies of the executable and the plugins.
  # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
  install(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    if (APPLE)
      file(GLOB_RECURSE QTPLATFORMPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/MacOS/platforms/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      set(QTPLUGINS \"\${QTPLUGINS};\${QTPLATFORMPLUGINS}\")
    endif (APPLE)
    file(GLOB_RECURSE KID3PLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_PLUGINSDIR}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    set(bundle_libs \"\${QTPLUGINS};\${KID3PLUGINS}\")
    if (APPLE AND BUILD_CLI_APP)
      set(bundle_libs \"\${bundle_libs};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}/kid3-cli\")
    endif (APPLE AND BUILD_CLI_APP)
    fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
    ")

endif (APPLE OR WIN32)

if (WIN32)
  if (NOT HAVE_QT5)
    # Unfortunately, the binutils which come with the gcc-4.4.0 in the MinGW
    # for Qt generate an executable which cannot be analyzed with dumpbin.
    # This happens when Kid3 is linked with libav (used with Chromaprint).
    # Therefore, the dependencies for kid3.exe are not added to the bundle.
    # This workaround adds the missing files.
    install(FILES "${QT_BINARY_DIR}/QtNetwork4.dll"
                  "${QT_BINARY_DIR}/QtXml4.dll"
                  "${QT_BINARY_DIR}/libwinpthread-1.dll"
                  "${QT_BINARY_DIR}/libiconv-2.dll"
            DESTINATION ${WITH_BINDIR})
  else (NOT HAVE_QT5)
    # Use reduced size ICU libraries, QTBUG-29828, QTBUG-38259.
    # A folder with reduced ICU libraries can be copied to the Qt bin directory.
    get_target_property(_qtBinDir Qt5::qmake LOCATION)
    get_filename_component(_qtBinDir ${_qtBinDir} PATH)
    install(DIRECTORY "${_qtBinDir}/icu_reduced/"
            DESTINATION ${WITH_BINDIR} OPTIONAL)
    # Install missing DLLs.
    file(GLOB _sslDlls "${_qtBinDir}/../../../Tools/mingw*/opt/bin/*eay32.dll")
    install(FILES "${_qtBinDir}/Qt5Xml.dll" ${_sslDlls}
            DESTINATION ${WITH_BINDIR})
  endif (NOT HAVE_QT5)
endif (WIN32)

=== src/plugins/acoustidimport/CMakeLists.txt ===
if(WITH_CHROMAPRINT)

  macro(find_gstreamer)
    find_package(PkgConfig)
    set(WITH_GSTREAMER_VERSION "" CACHE STRING
      "GStreamer version to use or list of versions to check")
    if (WITH_GSTREAMER_VERSION)
      set(_checkedGstVersions ${WITH_GSTREAMER_VERSION})
    else (WITH_GSTREAMER_VERSION)
      set(_checkedGstVersions "1.0;0.10")
    endif (WITH_GSTREAMER_VERSION)
    foreach (_gstVersion ${_checkedGstVersions})
      pkg_check_modules(GSTREAMER gstreamer-${_gstVersion})
      if (GSTREAMER_FOUND)
        if (NOT WITH_GSTREAMER_VERSION)
          message(STATUS "GStreamer ${_gstVersion} selected, "
            "use WITH_GSTREAMER_VERSION for another version.")
        endif (NOT WITH_GSTREAMER_VERSION)
        if (_gstVersion STREQUAL "0.10" AND WITH_PHONON)
          message(WARNING "If Phonon uses a different GStreamer version "
            "it will probably hang when playing.")
        endif ()
        break()
      endif (GSTREAMER_FOUND)
    endforeach (_gstVersion ${WITH_GSTREAMER_VERSION})
  endmacro(find_gstreamer)

  set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
  find_package(Chromaprint REQUIRED)
  if(CHROMAPRINT_INCLUDE_DIR AND CHROMAPRINT_LIBRARIES)
    set(HAVE_CHROMAPRINT 1)
  endif(CHROMAPRINT_INCLUDE_DIR AND CHROMAPRINT_LIBRARIES)
  set(CHROMAPRINT_INCLUDES ${CHROMAPRINT_INCLUDE_DIR})
  set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBRARIES})
  if(WITH_FFMPEG)
    find_package(FFmpeg REQUIRED)
  elseif(WITH_GSTREAMER)
    find_gstreamer()
    if (NOT GSTREAMER_FOUND)
      message(FATAL_ERROR "Could not find GStreamer")
    endif (NOT GSTREAMER_FOUND)
  elseif(HAVE_QT5 AND WITH_QAUDIODECODER)
    message(STATUS "QAudioDecoder selected for decoding.")
  else(WITH_FFMPEG)
    # Neither FFmpeg nor GStreamer is forced, select FFmpeg if Chromaprint
    # depends on it or if on Windows or Mac OS X.
    include(GetPrerequisites)
    get_prerequisites(${CHROMAPRINT_LIBRARIES} _chromaprintDeps 0 0 "" "")
    if(_chromaprintDeps MATCHES "libavcodec" OR APPLE OR WIN32)
      message(STATUS "FFmpeg selected for decoding, use WITH_GSTREAMER=ON to use GStreamer instead.")
      find_package(FFmpeg REQUIRED)
    else()
      message(STATUS "GStreamer selected for decoding, use WITH_FFMPEG=ON to use FFmpeg instead.")
      find_gstreamer()
    endif()
  endif(WITH_FFMPEG)
  if(GSTREAMER_FOUND)
    set(HAVE_GSTREAMER 1)
    set(CHROMAPRINT_CFLAGS ${GSTREAMER_CFLAGS_OTHER})
    set(CHROMAPRINT_INCLUDES ${CHROMAPRINT_INCLUDES} ${GSTREAMER_INCLUDE_DIRS})
    set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${GSTREAMER_LDFLAGS})
  elseif(FFMPEG_LIBAVFORMAT_FOUND AND FFMPEG_LIBAVCODEC_FOUND AND FFMPEG_LIBAVUTIL_FOUND)
    if (FFMPEG_LIBAVRESAMPLE_FOUND)
      set(HAVE_AVRESAMPLE 1)
      set(CHROMAPRINT_INCLUDES ${CHROMAPRINT_INCLUDES} ${FFMPEG_LIBAVRESAMPLE_INCLUDE_DIRS})
      set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${FFMPEG_LIBAVRESAMPLE_LIBRARIES})
    elseif (FFMPEG_LIBSWRESAMPLE_FOUND)
      set(HAVE_SWRESAMPLE 1)
      set(CHROMAPRINT_INCLUDES ${CHROMAPRINT_INCLUDES} ${FFMPEG_LIBSWRESAMPLE_INCLUDE_DIRS})
      set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${FFMPEG_LIBSWRESAMPLE_LIBRARIES})
    else (FFMPEG_LIBAVRESAMPLE_FOUND)
      include(CheckFunctionExists)
      set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
      set(CMAKE_REQUIRED_LIBRARIES
        ${FFMPEG_LIBAVFORMAT_LIBRARIES}
        ${FFMPEG_LIBAVCODEC_LIBRARIES}
        ${FFMPEG_LIBAVUTIL_LIBRARIES})
      check_function_exists(av_audio_convert HAVE_AV_AUDIO_CONVERT)
      set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
    endif (FFMPEG_LIBAVRESAMPLE_FOUND)
    set(HAVE_FFMPEG 1)

    set(CHROMAPRINT_INCLUDES ${CHROMAPRINT_INCLUDES} ${FFMPEG_LIBAVCODEC_INCLUDE_DIRS} ${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS} ${FFMPEG_LIBAVUTIL_INCLUDE_DIRS})
    set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${FFMPEG_LIBAVFORMAT_LIBRARIES} ${FFMPEG_LIBAVCODEC_LIBRARIES} ${FFMPEG_LIBAVUTIL_LIBRARIES})
    if(WIN32 OR APPLE)
      set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${ZLIB_LIBRARIES})
    endif(WIN32 OR APPLE)
  elseif(WITH_CHROMAPRINT_FFMPEG)
    find_package(FFmpeg REQUIRED)
    set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${FFMPEG_LIBAVCODEC_LIBRARIES} ${FFMPEG_LIBAVUTIL_LIBRARIES})
  endif(GSTREAMER_FOUND)
  if (APPLE)
    find_library(ACCELERATE_LIBRARIES Accelerate)
    set(CHROMAPRINT_LIBS ${CHROMAPRINT_LIBS} ${ACCELERATE_LIBRARIES})
  endif (APPLE)

  configure_file(acoustidconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/acoustidconfig.h)

  add_definitions(${CHROMAPRINT_CFLAGS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CHROMAPRINT_INCLUDES})

  if (WIN32 AND HAVE_CHROMAPRINT)
    add_definitions(-DCHROMAPRINT_NODLL)
  endif (WIN32 AND HAVE_CHROMAPRINT)

  set(plugin_SRCS
    abstractfingerprintdecoder.cpp
    fingerprintcalculator.cpp
    musicbrainzclient.cpp
    acoustidimportplugin.cpp
  )

  set(plugin_MOC_HDRS
    abstractfingerprintdecoder.h
    fingerprintcalculator.h
    musicbrainzclient.h
    acoustidimportplugin.h
  )

  if (HAVE_GSTREAMER)
    set(plugin_SRCS ${plugin_SRCS} gstfingerprintdecoder.cpp)
  elseif (HAVE_FFMPEG)
    set(plugin_SRCS ${plugin_SRCS} ffmpegfingerprintdecoder.cpp)
  elseif (HAVE_QT5)
    set(plugin_SRCS ${plugin_SRCS} qtfingerprintdecoder.cpp)
    set(plugin_MOC_HDRS ${plugin_MOC_HDRS} qtfingerprintdecoder.h)
  endif ()

  set(plugin_NAME AcoustidImport)

  if (WITH_GCC_PCH)
    add_definitions(${GCC_PCH_COMPILE_FLAGS})
  endif (WITH_GCC_PCH)

  string(TOLOWER ${plugin_NAME} plugin_TARGET)

  qt4_wrap_cpp(plugin_GEN_MOC_SRCS ${plugin_MOC_HDRS})

  add_library(${plugin_TARGET} ${plugin_SRCS} ${plugin_GEN_MOC_SRCS})
  target_link_libraries(${plugin_TARGET} kid3-core ${BASIC_LIBRARIES} ${CHROMAPRINT_LIBS})
  if (APPLE AND CMAKE_EXE_LINKER_FLAGS MATCHES "-arch i386")
    # To suppress linker error
    # ld: illegal text-relocation to non_lazy_ptr in ../libavformat.a
    # (allformats.o) from _av_register_all in ../libavformat.a(allformats.o)
    # for architecture i386
    SET_TARGET_PROPERTIES(${plugin_TARGET} PROPERTIES LINK_FLAGS -Wl,-read_only_relocs,suppress)
  endif (APPLE AND CMAKE_EXE_LINKER_FLAGS MATCHES "-arch i386")

  INSTALL_KID3_PLUGIN(${plugin_TARGET} ${plugin_NAME})
endif(WITH_CHROMAPRINT)

=== src/plugins/taglibmetadata/CMakeLists.txt ===
set(TAGLIB_LIBRARIES)
set(TAGLIB_CFLAGS)
if(WITH_TAGLIB)
  if (WIN32)
    find_library(TAGLIB_LIBRARIES NAMES tag)
    find_path(TAGLIB_INCLUDE_DIR taglib/taglib.h)
    if (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
      set(TAGLIB_CFLAGS -I${TAGLIB_INCLUDE_DIR}/taglib -I${TAGLIB_INCLUDE_DIR} -DTAGLIB_STATIC)
      set(HAVE_TAGLIB 1)
      message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
      set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES})
    endif (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
  else (WIN32)
    find_program(TAGLIBCONFIG_EXECUTABLE NAMES taglib-config PATHS /usr/bin /usr/local/bin ${BIN_INSTALL_DIR})
    if(TAGLIBCONFIG_EXECUTABLE)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --libs RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_LIBRARIES)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --cflags RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_CFLAGS)
      exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --version RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_VERSION)
      if(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
        if(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
          set(HAVE_TAGLIB 1)
          message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
          set(TAGLIB_LIBRARIES ${TAGLIB_LIBRARIES} ${ZLIB_LIBRARIES} -lstdc++)
        endif(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
      endif(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
    endif(TAGLIBCONFIG_EXECUTABLE)
  endif (WIN32)
  if (NOT HAVE_TAGLIB)
    message(FATAL_ERROR "Could not find Taglib")
  endif (NOT HAVE_TAGLIB)
endif(WITH_TAGLIB)
if (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)
  set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TAGLIB_LIBRARIES})
  set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
  set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${TAGLIB_CFLAGS})
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  file.save(3, false, 3);\n  return 0;\n}\n" HAVE_TAGLIB_ID3V23_SUPPORT)
  CHECK_CXX_SOURCE_COMPILES("#include <mpegfile.h>\n#include <xmfile.h>\nint main() {\n  TagLib::MPEG::File file(\"somefile.mp3\");\n  return dynamic_cast<TagLib::XM::Properties*>(file.audioProperties()) != 0;\n}\n" HAVE_TAGLIB_XM_SUPPORT)
  set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
  set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})


  configure_file(taglibconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/taglibconfig.h)

  add_definitions(${TAGLIB_CFLAGS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR} ../../core/tags taglibext)

  set(plugin_SRCS
    taglibmetadataplugin.cpp
    taglibfile.cpp
    taglibext/aac/aacfiletyperesolver.cpp
    taglibext/mp2/mp2filetyperesolver.cpp
  )

  if (NOT ${TAGLIB_VERSION} VERSION_GREATER 1.9.1)
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/synchronizedlyricsframe.cpp
      taglibext/eventtimingcodesframe.cpp
    )
  endif (NOT ${TAGLIB_VERSION} VERSION_GREATER 1.9.1)

  if (NOT ${TAGLIB_VERSION} VERSION_LESS 1.9.1)
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/dsf/dsffiletyperesolver.cpp
      taglibext/dsf/dsffile.cpp
      taglibext/dsf/dsfproperties.cpp
      taglibext/dsf/dsfheader.cpp
    )
  endif (NOT ${TAGLIB_VERSION} VERSION_LESS 1.9.1)

  if (TAGLIB_VERSION STREQUAL "1.4")
    set(plugin_SRCS ${plugin_SRCS}
      taglibext/urllinkframe.cpp
      taglibext/unsynchronizedlyricsframe.cpp
      taglibext/generalencapsulatedobjectframe.cpp
      taglibext/speex/speexfile.cpp
      taglibext/speex/speexproperties.cpp
      taglibext/speex/taglib_speexfiletyperesolver.cpp
      taglibext/trueaudio/taglib_trueaudiofiletyperesolver.cpp
      taglibext/trueaudio/ttafile.cpp
      taglibext/trueaudio/ttaproperties.cpp
      taglibext/wavpack/taglib_wavpackfiletyperesolver.cpp
      taglibext/wavpack/wvfile.cpp
      taglibext/wavpack/wvproperties.cpp
    )
  endif (TAGLIB_VERSION STREQUAL "1.4")

  set(plugin_MOC_HDRS
    taglibmetadataplugin.h
  )

  set(plugin_NAME TaglibMetadata)

  if (WITH_GCC_PCH)
    add_definitions(${GCC_PCH_COMPILE_FLAGS})
  endif (WITH_GCC_PCH)

  string(TOLOWER ${plugin_NAME} plugin_TARGET)

  qt4_wrap_cpp(plugin_GEN_MOC_SRCS ${plugin_MOC_HDRS})

  add_library(${plugin_TARGET} ${plugin_SRCS} ${plugin_GEN_MOC_SRCS})
  target_link_libraries(${plugin_TARGET} kid3-core ${BASIC_LIBRARIES} ${TAGLIB_LIBRARIES})

  INSTALL_KID3_PLUGIN(${plugin_TARGET} ${plugin_NAME})
endif (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)

=== debian/changelog ===
kid3 (3.4.2-1build1) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:04:47 +0000

kid3 (3.4.2-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 31 Aug 2016 10:40:42 +0200

kid3 (3.4.1-1) unstable; urgency=medium

  * New upstream release.
    - Remove merged patch 01-spelling-error.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 07 Jul 2016 10:05:39 +0200

kid3 (3.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Use secure Vcs-Browser URL.
  * Bump Standards-Version to 3.9.8 (no changes required).
  * Add patch 01-spelling-error to fix a spelling error.
  * Remove unused file paragraph from debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 03 May 2016 12:43:58 +0200

kid3 (3.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Enable full hardening.
  * Bump Standards-Version to 3.9.7 (no changes required).

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 17 Mar 2016 19:37:13 +0100

## kid3 3.4.4

=== debian/changelog ===
kid3 (3.4.4-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15.
  * debian/control: revert to KDE 4 and Qt 4 build-depends.
  * debian/rules: build against Qt 4 instead of Qt 5.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 04 Jan 2017 09:48:59 -0800

kid3 (3.4.4-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-spelling-error.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 23 Dec 2016 09:00:02 +0100

kid3 (3.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Fix debian/watch.
  * Add patch 01-spelling-error to fix a spelling error.
  * Some fixes in debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 09 Nov 2016 10:31:58 +0100

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Urs Fleisch <ufleisch@users.sourceforge.net>
Build-Depends: debhelper (>= 9),
# KDE 5 BEGIN
# extra-cmake-modules,
# kio-dev,
# kdoctools-dev,
# qtmultimedia5-dev,
# qtdeclarative5-dev,
# qttools5-dev,
# qttools5-dev-tools,
# qtdeclarative5-dev-tools,
# qml-module-qtquick2,
# KDE 5 END
# KDE 4 BEGIN
 libqt4-dev, kdelibs5-dev,
# KDE 4 END
 cmake,
 python,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-xsl,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 3.9.6
Homepage: http://kid3.sourceforge.net/
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kid3/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kid3/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
# KDE 5 BEGIN
#Recommends: libqt5multimedia5-plugins
# KDE 5 END
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 This package contains common libraries and data used by both kid3 and kid3-qt.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE audio tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains a command line interface for Kid3, for a GUI you can
 use kid3-qt or kid3.

=== debian/rules ===
#!/usr/bin/make -f

# To build with KDE 5:
# In dh_auto_configure, add -DWITH_QT5=ON and remove
# CONFIG_INSTALL_DIR, DATA_INSTALL_DIR, HTML_INSTALL_DIR, KCFG_INSTALL_DIR.
# To get rid of the warning, remove the rm command in dh_auto_install.
# Adapt control and kid3.install according to the comments in the files.
DEB_CMAKE_PREFIX = /usr
DEB_CONFIG_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/kde4/config
DEB_HTML_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/doc/kde/HTML

# KDE 5 BEGIN
#BASE_CMAKE_DEFS = -DWITH_QT5=ON -DKDE_INSTALL_BINDIR=$(DEB_CMAKE_PREFIX)/bin -Wno-dev
# KDE 5 END
# KDE 4 BEGIN
BASE_CMAKE_DEFS = -DCONFIG_INSTALL_DIR=$(DEB_CONFIG_INSTALL_DIR) \
  -DDATA_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/share/kde4/apps \
  -DHTML_INSTALL_DIR=$(DEB_HTML_INSTALL_DIR) \
  -DKCFG_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/share/kde4/config.kcfg
# KDE 4 END

%:
	dh $@ --parallel --builddirectory=kid3-build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONF_INSTALL_DIR=/etc \
		-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
		$(BASE_CMAKE_DEFS) \
		-DLIB_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/lib/kid3 \
		-DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
		-DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \
		-DCMAKE_C_FLAGS="$(CFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS)"

override_dh_auto_build:
	dh_auto_build
	cp kid3-build/doc/en/kid3.1 kid3-build/doc/en/kid3-core.1
	cp kid3-build/doc/de/kid3.1 kid3-build/doc/de/kid3-core.de.1

override_dh_auto_install:
	dh_auto_install
# KDE 4 BEGIN
	-rm $(CURDIR)/debian/tmp/usr/share/doc/kde/HTML/*/kid3/common
# KDE 4 END

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_compress:
	dh_compress --exclude=.docbook

## kid3 3.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -115,12 +115,12 @@
 
 # Version information
 set(CPACK_PACKAGE_VERSION_MAJOR 3)
-set(CPACK_PACKAGE_VERSION_MINOR 4)
-set(CPACK_PACKAGE_VERSION_PATCH 2)
+set(CPACK_PACKAGE_VERSION_MINOR 5)
+set(CPACK_PACKAGE_VERSION_PATCH 0)
 set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
-#set(CPACK_PACKAGE_VERSION "git20160517")
-set(RELEASE_YEAR 2016)
+#set(CPACK_PACKAGE_VERSION "git20170517")
+set(RELEASE_YEAR 2017)
 
 # Platform specific default installation paths
 if (APPLE)
@@ -148,7 +148,7 @@
   set(WITH_LIBDIR_DEFAULT ".")
   set(WITH_PLUGINSDIR_DEFAULT ".")
   set(QT_ANDROID_APP_VERSION ${KID3_VERSION})
-  set(QT_ANDROID_APP_VERSION_CODE 5)
+  set(QT_ANDROID_APP_VERSION_CODE 9)
 else (APPLE)
   set(WITH_DATAROOTDIR_DEFAULT "share")
   set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
@@ -238,7 +238,7 @@
     set(QT_USE_QTMAIN TRUE)
   endif (WIN32)
   set(QT_USE_QTDBUS ${WITH_DBUS})
-  find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS})
+  find_package(Qt4 4.7 COMPONENTS ${_QT4_COMPONENTS})
   if (Qt4_FOUND OR QT4_FOUND)
     include (${QT_USE_FILE})
     if (NOT WITH_QT4)

=== src/app/qt/CMakeLists.txt ===
--- 
+++ 
@@ -121,7 +121,18 @@
   BUNDLE DESTINATION .
   RUNTIME DESTINATION ${WITH_BINDIR})
 
-if (APPLE OR WIN32)
+if (LINUX_SELF_CONTAINED)
+  # Change RPATH/RUNPATH of executable/library.
+  macro(CHANGE_RPATH _rpath _file)
+    install(CODE "
+      execute_process(COMMAND chrpath -r ${_rpath} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_file}\")
+      ")
+  endmacro()
+
+  set_target_properties(${KID3_EXECUTABLE} PROPERTIES INSTALL_RPATH "\$ORIGIN")
+endif (LINUX_SELF_CONTAINED)
+
+if (APPLE OR WIN32 OR LINUX_SELF_CONTAINED)
 
   # Put Qt libraries and plugins into installation package to create a
   # standalone bundle on Mac OS X and Windows
@@ -144,6 +155,9 @@
     FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                    PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}")
 
+  if (LINUX_SELF_CONTAINED)
+    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqjpeg${CMAKE_SHARED_LIBRARY_SUFFIX}")
+  endif ()
   if (HAVE_QT5)
     if (APPLE)
       install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
@@ -159,6 +173,15 @@
       install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
         DESTINATION ${plugin_dest_dir}
         FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    elseif (LINUX_SELF_CONTAINED)
+      install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
+        DESTINATION ${plugin_dest_dir}
+        FILES_MATCHING PATTERN "libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
+      CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
+      install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
+        DESTINATION ${plugin_dest_dir}
+        FILES_MATCHING PATTERN "libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
+      CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/mediaservice/libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
     endif (APPLE)
   endif (HAVE_QT5)
 
@@ -202,7 +225,7 @@
     fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
     ")
 
-endif (APPLE OR WIN32)
+endif (APPLE OR WIN32 OR LINUX_SELF_CONTAINED)
 
 if (WIN32)
   if (NOT HAVE_QT5)
@@ -229,3 +252,21 @@
             DESTINATION ${WITH_BINDIR})
   endif (NOT HAVE_QT5)
 endif (WIN32)
+
+if (LINUX_SELF_CONTAINED)
+  # Use reduced size ICU libraries.
+  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
+  get_target_property(_qtBinDir Qt5::qmake LOCATION)
+  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
+  string(REPLACE "/bin" "/lib" _qtLibDir "${_qtBinDir}")
+  install(CODE "
+    if (EXISTS \"${_qtLibDir}/icu_reduced\")
+      file(GLOB _iculibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/libicu*\")
+      if (_iculibs)
+        file(REMOVE \${_iculibs})
+      endif ()
+    endif ()
+  ")
+  install(DIRECTORY "${_qtLibDir}/icu_reduced/"
+          DESTINATION ${WITH_BINDIR} OPTIONAL)
+endif (LINUX_SELF_CONTAINED)

=== debian/changelog ===
kid3 (3.5.0-2) unstable; urgency=medium

  * Correct URL in Vcs-Svn control field.
  * Bump debian/compat to level 10.
  * Install appstream metadata to /usr/share/metainfo/.
  * Overwrite lintian information vcs-field-uses-insecure-uri.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 02 Aug 2017 10:01:05 +0200

kid3 (3.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Uploading to unstable.
  * Bump Standards-Version to 4.0.0 (no changes required).

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 30 Jun 2017 10:55:36 +0200

kid3 (3.4.5-1) experimental; urgency=low

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 31 Mar 2017 10:13:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,20 @@
 Source: kid3
 Section: kde
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-Bugs: mailto: <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Urs Fleisch <ufleisch@users.sourceforge.net>
-Build-Depends: debhelper (>= 9),
-# KDE 5 BEGIN
-# extra-cmake-modules,
-# kio-dev,
-# kdoctools-dev,
-# qtmultimedia5-dev,
-# qtdeclarative5-dev,
-# qttools5-dev,
-# qttools5-dev-tools,
-# qtdeclarative5-dev-tools,
-# qml-module-qtquick2,
-# KDE 5 END
-# KDE 4 BEGIN
- libqt4-dev, kdelibs5-dev,
-# KDE 4 END
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Uploaders: Mark Purcell <msp@debian.org>,
+ Patrick Matthäi <pmatthaei@debian.org>
+Build-Depends: debhelper (>= 10),
+ extra-cmake-modules,
+ kio-dev,
+ kdoctools-dev,
+ qtmultimedia5-dev,
+ qtdeclarative5-dev,
+ qttools5-dev,
+ qttools5-dev-tools,
+ qtdeclarative5-dev-tools,
+ qml-module-qtquick2,
  cmake,
- python,
  libid3-3.8.3-dev,
  libflac++-dev,
  libvorbis-dev,
@@ -32,21 +26,35 @@
  pkg-config,
  libreadline-dev,
  xsltproc
-Standards-Version: 3.9.6
+Standards-Version: 4.0.0
 Homepage: http://kid3.sourceforge.net/
 Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kid3/trunk/
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kid3/
+Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kid3/
 
 Package: kid3-core
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-# KDE 5 BEGIN
-#Recommends: libqt5multimedia5-plugins
-# KDE 5 END
 Breaks: kid3 (<< 3.0.2-2)
 Replaces: kid3 (<< 3.0.2-2)
 Description: Audio tag editor core libraries and data
+ With Kid3, an ID3 tag editor for KDE you can:
+  * Edit ID3v1.1 tags in your MP3 files
+  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
+  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
+  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
+    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
+  * Edit tags of multiple files, e.g. the artist, album, year and genre
+    of all files of an album typically have the same values and can be
+    set together
+  * Generate tags from filenames
+  * Generate tags from the contents of tag fields
+  * Generate filenames from tags
+  * Generate playlist files
+  * Automatic case conversion and string translation
+  * Import and export album data
+  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
+ .
  This package contains common libraries and data used by both kid3 and kid3-qt.
 
 Package: kid3
